\documentclass[10pt, conference, a4paper]{IEEEtran}
\IEEEoverridecommandlockouts
% The preceding line is only needed to identify funding in the first footnote. If that is unneeded, please comment it out.
\usepackage{cite}
\usepackage{amsmath,amssymb,amsfonts}
\usepackage{algorithmic}
\usepackage{graphicx}
\usepackage{textcomp}
\usepackage{xcolor,colortbl}
\usepackage{tcolorbox}
\usepackage[inline]{enumitem}
\usepackage{float}
\usepackage{tikz}
\usepackage{mathtools}
\newcounter{magicrownumbers}
\newcommand\rownumber{\stepcounter{magicrownumbers}\arabic{magicrownumbers}}

\DeclarePairedDelimiter{\ceil}{\lceil}{\rceil}

\usetikzlibrary{positioning, fit, calc, shapes, arrows}
\usepackage[underline=false]{pgf-umlsd}
\graphicspath{{image/}}
\def\BibTeX{{\rm B\kern-.05em{\sc i\kern-.025em b}\kern-.08em
    T\kern-.1667em\lower.7ex\hbox{E}\kern-.125emX}}
\begin{document}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% visible editing comments in the PDF, per writer.

\newboolean{ShowComments}
\setboolean{ShowComments}{true}  % change to true to show remaining colorful author comments.
                                 % change to false to hide all author comments.
\ifthenelse{\boolean{ShowComments}}%
	{
		\newcommand{\ColorComment}[3]{%
				{\colorbox{#1}{\color{white}   \textsf{\textbf{#2}}} \textcolor{#1}{#3}}}%  Colorful box, initials, phrase
        \newcommand{\TR}[1]{\textcolor{Red}{#1}}
        \newcommand{\TB}[1]{\textcolor{Red}{#1}}
        \newcommand{\TO}[1]{\textcolor{Red}{#1}}
	}%
	{
		\newcommand{\ColorComment}[3]{}%  Do nothing at all
        \newcommand{\TR}[1]{#1}
        \newcommand{\TB}[1]{#1}
        \newcommand{\TO}[1]{#1}
	}%
%This commands are defined for commenting the paper
%David
\definecolor{dgucolor}{rgb}{0,0.5,0}\newcommand{\david}[1]{\ColorComment{dgucolor}{dgu}{#1}}
%Dirk
\definecolor{dotcolor}{rgb}{0.9,0.2,0}\newcommand{\dirk}[1]{\ColorComment{dotcolor}{dirk}{#1}}
%Joerg
\definecolor{jotcolor}{rgb}{0.1,0.1,0}\newcommand{\joerg}[1]{\ColorComment{jotcolor}{joerg}{#1}}
%info
\definecolor{infocolor}{rgb}{0,0,0.5}\newcommand{\info}[1]{\ColorComment{infocolor}{infocom}{#1}}

\title{Distributed Consensus through Network Support}

% \author{
% \IEEEauthorblockN{David Guzman}
% \IEEEauthorblockA{\textit{Huawei Technologies} \\
% \textit{Technical University of Munich}\\
% Munich, Germany \\
% david.guzman@tum.de}

% \and
% \IEEEauthorblockN{Dirk Trossen}
% \IEEEauthorblockA{\textit{Huawei Technologies} \\
% % \textit{Huawei Technologies}\\
% Munich, Germany \\
% dirk.trossen@huawei.com}

% \and
% \IEEEauthorblockN{Joerg Ott}
% \IEEEauthorblockA{\textit{Technical University of Munich}\\
% Munich, Germany \\
% ott@in.tum.de}

% }

\maketitle

\begin{abstract}
  Distributed consensus systems (DCSs) are increasingly important due to the often distributed realization of computational problems like voting systems and cryptocurrencies. The distributed nature of a DCS impacts the latency required to achieve consensus. In this paper, we develop an analytical model with empirically-based parameterization that provides an upper bound for that latency, thus enabling DCS operators to set expectations for its performance. We also propose a departure from the usual peer-to-peer-based DCS realization through an application-layer-based multicast approach. Our comparative analysis shows that our solution can improve convergence times by a factor of four while also ensuring targeted boundaries through the finality of the consensus convergence.
\end{abstract}

\begin{IEEEkeywords}
distributed consensus, routing, multicast
\end{IEEEkeywords}
\section{Introduction}\label{sect:introduction}

In an ever-more-connected world, implementing a computational problem, such as decentralized file storage \cite{Trautwein2022}, ledger partake \cite{Nakamoto2008, Wood2014, Cohen2019, Cai2021}, network bootstrap \cite{Bless2009, Bless2022}, system lock \cite{Burrows2006} and others, across distributed participants requires to progress over a \textit{state} representing the computational problem.

% across distributed participants in a network requires to reach consensus on the progress of the computation, often represented as a single coherent \textit{state}.
%Dirk: first comes the need for a state, then the need to agree on the state through consensus.

The distributed realization of the computational problem requires agreement on the current state among the distributed participants; this is commonly described as the \textit{consensus problem}.
The crucial insights in von Neuman's work \cite{Newman1956} show that reaching agreement among the majority of participants is enough to assume consensus; this is referred to as the \textit{majority rule}.
A distributed consensus system (DCS) implements the methods needed to reach consensus over a distributed state by achieving a majority agreement among its participants.

A key factor for DCS performance is the \textit{latency bound} within which the system achieves consensus, termed consensus latency in the following. While the costs of maintaining the needed communication relations between DCS participants is another key performance factor, depending on the specific realization of the DCS, we focus in this paper on the latency aspect due to its direct impact on the transactional state changes that the system can agree and confirm on, measured in transaction per second (TPS) and minutes correspondingly. For instance, seven TPS with $\approx60$mins confirmation delay and 30 TPS with confirmation delay of $\approx10$mins are typical indicators for Bitcoin and Ethereum, respectively \cite{Zhou2023}.

A key aspect in realizing a DCS is its nature of participation.
Different from reaching an agreement among well-known entities in a DCS, a \textit{permissionless} DCS lowers the requirements for participation, e.g., by not requiring strong authorization or use of trusted execution platforms. Instead, a simple sign-up procedure suffices together with the use of a distributed code base embodying the consensus protocol. For example, in Bitcoin and Ethereum, anyone can openly join and participate in the process to reach agreement \cite{Nakamoto2008,Wood2014}. Through this, such DCS provides a low barrier to entry into the consensus partaking; this is often captured as reaching consensus among potentially non-trustworthy participants.

For these permissionless systems, iterative diffusion is commonly used, such as in Ethereum and Bitcoin \cite{Maymounkov2002,Wood2014, Gao2019, Guzman2022}. Here, the original transaction, the desired state over which to reach consensus, is being diffused to an initial set of participants, which diffuses the information to another locally determined set of participants, and so on.
The problem here lies not only in bounding the latency for the diffusion of information to the majority of the participants but also in the finality of the diffusion in the first place, i.e., well judging that the majority has been reached and diffusion may thus end.

Our key contribution in this paper is bounding this latency for permissionless DCS platforms.
Specifically, we provide an analytical model for the latency to reach consensus, using empirical insights from an existing DCS, namely Ethereum, to parametrize our model.
With this contribution, we seek to enable DCS operators to operationally configure key parameters, such as diffusion set size, against a desired bound for the system's consensus latency and, thus, transaction throughput and confirmation delay that a DCS provides to its users.

Extending this contribution, we compare those insights with a strawman for an application layer multicast delivery model.
Also, here, we use empirical insights of existing Ethereum deployments to parameterize key design aspects, namely placing multicast replication points, to outline the possible performance gains in consensus latency compared to iterative diffusion. Although our strawman leaves details open, specifically those relating to building the necessary spanning trees for replication, our contribution shows the performance gains once those remaining design aspects are solved.
Specifically, we show a latency improvement of four times compared to existing iterative diffusion systems, while the finality of the consensus operation is achieved with higher certainty and less overhead of duplicated diffusion messages sent after consensus has already been reached.
These performance gains are rooted in the fewer diffusion steps required due to the aggregated nature of utilizing suitable spanning trees across DCS participants.

In the remainder of this paper, we outline the essential background on DCSs in Section \ref{sect:background} as the basis for our Distributed Consensus-as-a-Service (DCaaS) in Section \ref{sect:daas}.
We then assess the performance of existing DCS implementations, such as Ethereum, against our multicast-based strawman in Section \ref{sect:comparison}, quantifying the diffusion latency as a key performance indicator (KPI).
In Section \ref{sect:discussion}, we use this assessment to discuss its benefits, opportunities, and deployment impact before concluding in Section \ref{sect:conclusion}.

% - \info{B: The background is not explained: permissionless DCS, untrusted peers}

% \dirk{I suggest to add a paragraph on background of DCS, expanding on the first introductory paragraph. Important is to ease the description in from the DCS in general, into what constitutes the `concensus', i.e., the majority rule and what the membership models are - for the latter, I suggest to introduce permissionless as desirable from an organizational perspective, but posing the challenge of obtaining the majority agreement. Here, the key problem is that of latency for that obtaining of majority in a final sense - this latency creates other problems, such as working on inconsistent state through proofs but this is not the scope of this paper. What is important here is to clearly delineate the purpose of the DCS and its realization!! Having a p2p overlay is the latter, not the former (very deep down), while permissionless is still part of the purpose to me (since you want consensus across members of the DCS that are joining permissionless). With that, the problem of latency is tight to the problem, not the specific realization as much as possible.}

% - \info{D: The mentioning and incorporation of Ethereum is done poorly and does not support adequately the value of the paper.}
% \dirk{It would be good, through the separation of purpose and implementation, to keep Ethereum out of the introduction as much as possible, thus discussing the problem/purpose clearly, delegating the involvement of Ethereum towards the emperical evidence to parameterize the model, while claiming the insights to be of interest beyond just Ethereum.}

\section{Background on Distributed Consensus Systems}\label{sect:background}

Let us provide more background on realizing the majority rule for consensus building within a DCS.

As outlined in the introduction, consensus is built among DCS participants on advancing a common state related to a specific computational problem. Such state advances may realize, for instance, the insertion of a transaction (e.g., over a cryptocurrency) in a distributed ledger that keeps track of those transactions. Internet Protocol (IP) multicast may be an obvious choice to disseminate the state advance to the DCS participants. However, \cite{Guzman2022, Trossen2022, Crowcroft2022} have investigated several issues when doing so, some of which we will discuss in the context of the strawman approach in Section \ref{sect:daas:strawman}.

%Consensus in distributed systems is about deciding upon a shared state.
%Let us take as an example a blockchain system where a set of peers participate in the consensus about the state of a distributed ledger.
%Moreover, permissionless blockchains allow anyone to partake in the distributed ledger building with minimal rules to follow.

%Dirk: I don't know/think that the below adds anything to our discussion and it's still not fully understood from my side when reading it. Do we need those `blocks' and all here?
%Permissionless DCSs, such as Internet-scale blockchains, implement a diffusion and consensus phase.
%Initially, a peer proposes a transaction insertion into the system ledger, which must be disseminated.
%Peers collect and store the diffused transactions on their local ledger.
%In blockchain systems, peers store a set of transactions in blocks.
%In the second phase, a peer is chosen randomly to decide the distributed ledger's state.
%For example, in proof of work (PoW) based systems the completion of a cryptographic hashing realize a distributed peer selection \cite{Nakamoto2008}.
%The selected peer then disseminates the latest state, i.e., the consensus, in the system. In blockchains, it takes the form of a block of transactions.

% The transaction and block diffusion to the majority of the system is realized through a fixed size iterative approach.
% - Counting votes and comparing them to the majority leads to a decision for a single-valued shared state, here a common travel destination.
% If the majority of the peers agree on the transaction's validity, a decision is reached.
% In blockchains, this decission over a transaction is stored in blocks of transactions.
% Each peers chains these blocks resulting in a blockchain replicated accross the system.
% A random selection out of the entire system is performed to agree on the system state.

% Consensus may not require explicit peer membership to participate in state proposal or decision-making, realizing what is called a \textit{permissionless} DCS \cite{Nakamoto2008, Wood2014, Dimitri2022}, but a system protocol instead.
% - For instance, a new un-trusted member must remember all previous team's travel destinations before being able to vote.
% For instance, a new peer may store and synchronize the entire transaction ledger before partaking in the system agreement.
% - It may furthermore require to distribute proposals and decisions to most, in fact, half of the peers \cite{Newman1956}.
% It may furthermore require distributing proposals and decisions, e.g., transactions and blocks, to most, in fact, half of the peers \cite{Newman1956}.
% In these consensus systems, the key mechanism is that of the \textit{majority rule}, requiring to diffuse information to the majority of peers to guarantee agreement over a single-valued state \cite{Makur2020}.
% - \footnote{We do not consider the well-known result for Byzantine failures \cite{Lamport2019,Castro1999} since it is based on the atomic broadcast operation and a threat model.}
% Faulty peers can threaten the system, raising an even stronger diffusion bound, the so-called Byzantine failure limit. Here, diffusion is required to reach the entire system where $2/3$ of the peers are non-faulty participants \cite{Lamport2019, Castro1999}.
% \footnote{In blockchain protocols, a peer must download the latest checkpointed blockchain headers or the entire blockchain before proposing blocks (mining).}

% Dirk: I suggest removing this figure since it is SIGNIFICANTLY underspecified in the text and thus confusing. What is t_s? What are the other aspects in the legend? It seems that the text only talks about choosing N peers, disseminate, and so forth. So the figure is not needed, it seems, anymore.
%\begin{figure}[ht]
%  \centering
%  \includegraphics[width=0.49\textwidth]{image/peers-vs-t}
%  \caption{The diffusion process achieves the majority rule, i.e., the diffusion of information to half of the peers $m$, at time $t_m$. }
%  \label{fig:key_challenge}
%\end{figure}

% - Disseminating state proposals and consensus decisions at scale, i.e., to thousands of peers around the globe, while handling un-trusted peers requires a suitable communication approach.
%Disseminating state proposals and consensus decisions at scale, i.e., to thousands of peers around the globe, while handling untrusted peers requires a suitable communication approach.
%IP multicast, as first outlined in \cite{Deering1990}, may make this scaled diffusion of information possible but is fraud with issues, as discussed in \cite{Guzman2022, Trossen2022, Crowcroft2022}.
Existing DCS systems like Ethereum and Bitcoin instead implement a \textit{diffusion-based mechanism}. Each peer samples $N$ peers out of a set $S$ of possible recipients.
Since peers are generally unreliable or untrusted, owing to the permissionless nature of the DCS participation, the sample $N$ is drawn at random. After disseminating the state advance to the $N$ peers, those peers will, in turn, perform the same randomized selection of $N$ peers and so on.
This divide and conquer approach leads to iteratively disseminating information across the DCS with randomized selections at each peer \cite{Maymounkov2002}.

% - Here, the number of iterations needed to reach the majority, $m$, as a lower bound for the completion time $t_m$, as shown in Fig. \ref{fig:key_challenge}, determines the consensus performance.
Here, the number of iterations needed to reach the majority of peers in the system, $m \in \mathbb{N}^+ $, in a time interval $t_m \in \mathbb{R}^+$, determines the consensus performance of the DCS for a single transaction in the form of the transaction completion latency and, therefore, the transaction throughput of the overall system.
The critical challenge for this diffusion lies in completing the process, i.e., reaching the majority rule, possibly within a desired time or even ever. We will show in Section \ref{sect:comparison:iterative}, in line with \cite{Makur2019, Evans2000}, that this bounding is tied to the randomness and size of each diffusion.

The necessary communication for the diffusion is implemented as a peer-to-peer network over the IP \cite{Guzman2022, Trossen2021, Gao2019, Trautwein2022}, utilizing randomized multipoint relations, those relations are maintained through establishing and maintaining a \textit{pool of unicast relations} at each DCS peer. The authors in \cite{Kim2018, Trossen2021, Guzman2022} investigate in detail the active establishment and maintenance of that pool, while \cite{Cruciani2023} analyses its impact on network formation for similar mechanisms and small $N$.

For this peer-specific pool, a protocol is realized for pool discovery, establishment, and maintenance for relations being actively sought by each DCS peer while simultaneously handling requests from other peers. For this, locally generated random seeds, e.g., peer identifiers, assist in peer selection and discovery, while the unicast relations are constantly replenished for reasons discussed in \cite{Guzman2022}.

These mechanisms are prone to several issues, as studied in \cite{Guzman2022, Kim2018,Trossen2021}. First, it is expensive to maintain updated availability information of peers joining and leaving the DCS network, causing discovery and reachability tests to fail, necessitating the constant pool replenishment of $N$ peers. Second, validating dynamic and static capabilities requires an end-to-end unicast negotiation to support end-node heterogeneity. Third, timeouts and delays due to geographic distribution cause requests and responses to be dropped. Additionally, frequent changes in end-user addressing, firewalls, and network address translators (NATs) perturb the P2P relation establishment and cause imbalance in the communication \cite{Guzman2022}, often driven by conflicting traffic policies applied from region to region. Hence, \textit{any bounding of the size of multipoint relations $N$ needs to consider those issues to ensure consensus and convergence performance}.

Apart from the costs for those mechanisms, the randomized and highly dynamic nature of the peers' pools of relations impacts the latency for convergence to a consistent state, often taking many minutes for large-scale systems; we return to our model for bounding this latency in Section \ref{sect:comparison:iterative}. As a result, DCS platforms require methods to work on \textit{inconsistent state} during the consensus finding phase, akin to operating on a constantly amended proposal during an open consenting period. Here, information being diffused is partially operated over in a so-called \textit{proof} operations to generate temporary \textit{system states}, representing an inconsistent yet agreed ephemeral state until consensus is achieved. In order to avoid collusion in generating false states, methods such as \textit{proof of work} \cite{Nakamoto2008} or \textit{proof of stake} \cite{Dimitri2022}, and conciliation procedures are applied, where the trust in the system state is derived from the commitment to, e.g., spend high costs on computational operations over the incomplete state. This method, in turn, is responsible for much of the reported cost factor of popular DCS platforms, particularly for decentralized cryptographic currencies \cite{Drusinsky2022}.

\section{Distributed Consensus-as-a-Service (DCaaS)}\label{sect:daas}

Let us now outline an approach for realizing a DCS built on the notion of service-oriented communication. For this, we outline key observations derived from DCS implementations before introducing our system, integrated with novel methods for routing service requests at the network level.

\subsection{Key Observations on DCSes}\label{sect:daas:observations}

When looking at the operations within a DCS, we can observe three key \textit{services} that a DCS peer is providing to another peer. The first service is that of \textit{inserting new information} into the DCS to reach a consistent state of the (now extended) information. The second service relates to the first in that a recipient of new information \textit{diffuses this information} to one or more other peers; with this, the convergence over this information is realized through iteratively applying this service across the peers. Lastly, the third service allows a peer to \textit{retrieve the current consistent state} from one or more peers.

All of the above services follow the same invocation pattern of diffusion to a random set of $N$ peers, where the second service is recursive in that it is invoked (again) by its recipients. Furthermore, service invocation at another peer is constrained by several dynamic and static conditions to match the peer's capabilities, such as client and protocol versions used, specific algorithmic support such as for security, and replication status, e.g., based on checkpoints. Moreover, factors like peer reachability and availability impact the diffusion efficiency since suitable peers need to be found, as observed in \cite{Guzman2022, Kim2018}.

As marked in Section \ref{sect:background}, the iterative diffusion directly impacts convergence time, thus leading to various additional services being provided for working on inconsistent states, such as proof-of-work or proof-of-stake, which in turn require their own invocation patterns but are left out here.

\subsection{Service-Centric Model for a DCS}\label{sect:daas:proposed}

We can translate our observations into the following service-centric model for a DCS:
The DCS exposes three \textit{services}, namely $\texttt{I}$ to insert information of a transaction $\texttt{T}$, $\texttt{D}$ to diffuse the resulting state change from that transaction to $N$ DCS peers, and $\texttt{Q}$ to query the current state of the DCS. Each peer provides those services to other peers. It can thus serve as a \textit{service instance} $\texttt{I}_i$, $\texttt{D}_i$, and $\texttt{Q}_i$ to the aforementioned services with $i=1...S$, where $S$ is the number of overall DCS peers.

Services $\texttt{I}$ and $\texttt{Q}$ terminate within a single diffusion, with $\texttt{Q}$ providing up to $N$ individual responses to the invoking peer. In contrast, service $\texttt{D}$ is iterative in that an incoming invocation to $\texttt{D}$ invokes $N$ new invocations, and so forth. This iterative diffusion terminates in a peer when the received information is found in the peer's local information base.

%Figure \ref{fig:invocation} schematically outlines the invocation patterns used for our service-centric DCS with the right side showing the recursive diffusion of any state change from the newly inserted information $\texttt{T}$ and the left side showing its retrieval through a single level diffusion of service invocation $\texttt{Q}$.

%- \info{B: Fig 2 has a service T which is not defined (only I, D and Q are).}

%\dirk{I suggest removing T from the figure and only talk abotu the `transaction' as an input parameter to the iteration service I. This also needs reflection in the text, thus the services of the DCS are I, Q, and D but T is a mere parameter stemming from its use in a transactional ledger scenario.}

%\david{RESP: pic}

%\dirk{RESP: text}

% Dirk: this has been said already in the background section, not needed anymore
%Current DCS platforms realize those invocation patterns through peer-only operations, utilizing the end-to-end connectivity of the Internet. Work like \cite{Guzman2022, Kim2018, Trossen2021} outlines how, e.g., Ethereum systems, realize the underlying communication to achieve those invocation patterns for the service model we outline here by maintaining a pool of $N$ peers at each DCS peer with which to realize the diffusion pattern.

\subsection{Strawman for an (Overlay) Network based DCS}\label{sect:daas:strawman}

%- \info{B: It is not clear how the set S is known and maintained (a consistency issue).}

%\dirk{we need to clearly outline, already in the introduction, that the focus of the strawman is on the data plane performance, leaving the control plane out of scope. With that, we can outline assumptions on that control plane, such as knowing the group size.}

%\dirk{RESP}

The service-centric DCS model describes the diffusion among peers for any new information inserted in the DCS. As outlined in Section \ref{sect:background}, existing DCS platforms use an iterative diffusion process realized through a peer-to-peer network of DCS members. We contrast this iterative diffusion with a packet replication approach akin to multicast. Unlike IP multicast, first introduced in \cite{Deering1990}, we do not assume a purely in-network approach but propose an overlay network instead, with the option to deploy overlay components in ISP networks as a virtualized network function\footnote{https://www.etsi.org/technologies/nfv} or through a compute node hosted in existing cloud platforms.

Key to our strawman are dedicated \textit{Replication Points} (RPs) deployed as part of the DCS network. These RPs implement two essential functions, namely \textit{overlay topology formation} and \textit{packet replication}. We foresee peers obtaining the RPs to announce through, e.g., sign-up methods.

For the topology formation, RPs listen to peer announcements as service instances to the DCS services outlined in Section \ref{sect:daas:proposed}. Timed announcements can be used as a heartbeat mechanism to ensure the freshness of peer membership information in the overlay network. Criteria for selecting specific RPs may be geography, latency, or others.

For extending beyond a single RP, we suggest building spanning trees between RPs that allow for the distribution of service information from an RP-local peer to a given number of other peers in the tree. This procedure of sending to a given number of peers (in the spanning tree) is enabled by each RP aggregating peer announcements during the construction of the spanning tree by counting the number of downstream peers at each interface to another RP before propagating the announcements further to upstream RPs. For this, the \textit{next hop information base} (NIHB) in each RP is extended with an entry \textit{\# peers}. As a result, when eventually being propagated to the peer-facing RPs, the total number $S$ of downstream DCS peers can be retrieved from the peer-facing RP by summing up all interface entries for \textit{\# peers}, albeit only approximately due to possible churn in the set of peers connected to the RPs. This active spanning tree approach provides more up-to-date information on active peers in the overall DCS, replacing the pool creation and maintenance methods \cite{Guzman2022} done in each individual peer in today's DCS systems.

Figure \ref{fig:multicast_CP} illustrates our approach in a simple tree depth of two. RP1 is the root in this example, with an overall estimation for $S$ available through its NIHB entries and local peer announcements.

\begin{figure}[ht]
  \centering
  \includegraphics[width=0.45\textwidth]{image/multicast_tree}
  \caption{Invocation patterns for a service-centric DCS}
  \label{fig:multicast_CP}
\end{figure}

As for the specific mechanisms for building a spanning tree, a shared tree may be used. Alternatively, a (full or partial) mesh of RPs may be devised to build source-specific multicast (SSM) trees for each RP, e.g., utilizing methods outlined in \cite{RFC3569} albeit adjusted to the overlay nature of our strawman. Furthermore, we may utilize improvements on existing protocols, such as Protocol-Independent Multicast (PIM), made in \cite{SSM2012},  proposing to use unicast tunneling between replication points akin to our strawman. The authors in \cite{SSM2012} have shown that the costs for signaling messages to build the resulting spanning tree(s) can be significantly reduced, thus supporting Internet-scale deployments aligned with the goal of our strawman. Overall, we foresee a significant reduction of control traffic compared to the pool maintenance methods outlined in \cite{Guzman2022} through our approach of peer announcement and building an RP spanning tree overlay, particularly when considering a low churn in the overall DCS. However, we recognize that future work will be required to assess that cost aspect further.

The aggregation of peer announcements, as mentioned earlier, and thus the RP-local determination of the overall DCS peer number $S$, is key for the packet replication function of the RPs since, unlike existing IP multicast, packets are not replicated to \textit{all} clients but to a dynamic number $d$ of peers. Here, $d$ is defined through the majority rule as at least half, i.e., $S/2$, of all announced peers, plus some overhead $\delta$ to account for possible packet losses and churn among DCS peers. To realize this semantic of \textit{$d$ out of all peers} multicast, a peer that initiates a send operation first queries $S$ from its local RP, which in turn determines this number from the aggregated \textit{\# instances} entry in its next hop table, which then allows the peer to determine $d=S/2 + \delta$.

% - \info{B: The analysis is shallow with errors. For instance in the stated expression at the end of Sec III.C, $d_i=d*d_i/d_t$, here $d_i$ cancels and leaved $d=d_t...$
% The solution relies on "an overlay network with the option to deploy overlay components in ISP networks" - the delay cost of this should be included for fair comparisons.}

% \dirk{look into this and revise}

% \david{RESP}

The peer then provides $d$ as a parameter to its request for diffusion to its local RP, based upon which any traversing RP can now implement the required packet replication function as follows: The RP first determines all NIHB entries for a given service, with the total being $w$, and retrieves the NIHB-specific \textit{\# instances} entries for each,
defined as $\mathtt{inst}_i$. It then distributes the provided parameter $d$ of the incoming request as a ratio,$a_i$, of the \textit{\# instances} entries to the sum of all downstream
instances, i.e., the RP calculates $d_t = \sum_{n=1}^{w} \mathtt{inst}_n$ with $a_i = (d\cdot d_i)/d_t$. It then replaces the incoming parameter $d$ with the determined
ratio $a_i$ and forwards the request down the NIHB interface $i$ to the next level RP if the determined ratio is at least 1.
To avoid topological bias towards paths with a strong presence of peers, the RP may choose to send at least one request downstream of those NIHB entries where the ratio
is determined as zero.

\section{Comparing Iterative with Multicast Diffusion}\label{sect:comparison}

%- \info{B: From the slight understanding that could be obtained, it is not clear that the comparison in the paper is not fair: The cost of establishing and maintaining the multicast trees as well as the mesh among the replication points appears not to be considered. I cannot see why it is less costly to maintain those structures on an application level (without network support) than to maintain p2p relations (which could be latency aware, which is not considered here).}

%\dirk{Again, we must clearly position this as work on the data plane, not control plane. Guzman2022 was on control plane overhead and impact, and there's ample literature on SSM overhead - this paper is not about that but what, if those overheads are understood and taken into account, the resulting data plane could perform from a latency perspective. Again, same contributions here in introduction and start of Section III.C needed.}

%\dirk{RESP}

%- \info{C: On the other hand, the RPs in the proposed overlay architecture seem to be special nodes that are assumed to be always available (although this is not explicitly mentioned in the paper). What is the cost of implementing/maintaining such special nodes?}

%\dirk{same as previous comment of mine. However, we can/should weave this `special node' aspect into the possibly new insights on clustering.}

%\dirk{RESP}
% DIRK: added some text on control vs data plane performance in line with our previous explanations of the focus of the paper.

When considering the potential benefits of our strawman outlined in the previous section, it becomes apparent that the random diffusion is built on the fly by the RPs based on the availability announcements of peers. This RP-assisted approach contrasts against existing mechanisms described in \cite{Guzman2022, Kim2018, Trossen2021, Cruciani2023}, where peers must actively (and independently) discover and negotiate sessions with other peers. Also, the RP-based randomization avoids consensus centralization since it dodges the super-peer's higher connection degree, contrary to the central behavior shown in \cite{Guzman2022} for the existing Ethereum, in \cite{Tumas2023} for XRP Ledger, and in \cite{Javarone2018} for Bitcoin.

These aspects of building and maintaining the DCS overlay, positioned as the \textit{control plane} of a DCS, are key to comparing both approaches regarding their cost and overhead in terms of messaging, as done in \cite{Guzman2022} for iterative diffusion.

However, we keep our following evaluation in line with the previously expressed focus of our paper in studying what we could call the \textit{data plane} performance, as chiefly represented by the \textit{convergence time} $t_m$ towards a consistent state, including the possibility to judge the finality of that convergence. To do so, we develop suitable diffusion models for both dissemination approaches.

\subsection{Model for Iterative Diffusion}\label{sect:comparison:iterative}
\begin{figure}[ht]
  \centering
  \includegraphics[width=0.40\textwidth]{image/peers-vs-t-hoilland}
  \caption{Model example for a baseline diffusion in a DCS with $S=72k$ peers, $m=36k$ peers, $N=50$ peers, $t_d(N)=0.200$s, and $u(t)=1$}
  \label{fig:iterative_diffusion_meas}
\end{figure}
% \dirk{In Fig 2, shouldn't the legend show a red line for the `diffusion process'? In fact, the entire legend does not show colors but the figure lines do have colors}

To develop a model for iterative diffusion, let us consider $S$ as the total number of DCS peers while each diffusion step is performed to $N$ peers. As outlined in Section \ref{sect:background}, and in more detail in \cite{Kim2018, Guzman2022}, those $N$ peers are sampled from the respective peer's local pool. A diffusion step, information propagation to $N$ peers, requires $t_d(N)$ [ms]. The process aims at reaching at least half of the peers $m$, the majority rule in $t_m$ [ms], and $S$ peers in $t_S$ [ms], as in Fig. \ref{fig:iterative_diffusion_meas}. Moreover, at each iteration, the diffusion sets are disjoint with expected probability $u(t)$ for a fixed $N$ where $u(t)=1$ signifies uniqueness across all diffusions.

We derive from insights into existing DCSs, \cite{Kim2018, Cruciani2023} that a peer at each iteration parallelizes its invocations. Thus, we estimate the individual iteration latency, $t_d(N)$ as diffusion to a single peer within the set $N$. With this, we can formulate the evolution of an iterative diffusion in a DCS over time $t$ as

\begin{equation}\label{eq:model}
  m < (u(t)N)^{t/t_d(N)} , \quad \forall m,N,S \in \mathbb{N}^+, t,t_d(N) \in \mathbb{R}^+,
\end{equation}

where $m$ unique peers realize the majority rule at time $t_m=t_d(N) \cdot (\log_N(m) -1)$.

Let us first outline a baseline for Eq. \ref{eq:model}, for which we use typical Internet P2P system latencies of $t_d(N)=0.200$s \cite{Hoiland2016}, an empirical average latency from a long-tailed distribution, and assume a complete uniqueness at each iteration, i.e., $u(t)=1$. Fig. \ref{fig:iterative_diffusion_meas} shows an illustrative example for this baseline for the default iteration size of $N=50$ in an Ethereum system with $72$k active peers with the dataset obtained from the authors in \cite{Trossen2021,Guzman2022}.

In the following, we will refine our baseline by utilizing empirical insights for the two critical dependencies of our model, namely the diffusion latency $t_d(N)$ and the uniqueness $u(t)$ between each diffusion iteration.

\subsubsection{Distribution of the Diffusion Latency}\label{sect:diffusion_latency}

In order to refine $t_d(N)$ from our baseline, we utilize insights from \cite{Guzman2022, Kim2018} into the complexities to ensure reachability and communication in a DCS and the incurring latencies from those mechanisms. For this, we approximate $t_d(N)$ based on measurements of around 1.8M data points, gathered at a public peer by the authors in \cite{Guzman2022}, shown as the blue line in Figure \ref{fig:t_d_N_approximation}.

\begin{figure}[ht]
  \centering
  \includegraphics[width=0.40\textwidth]{image/t_d_N}
  \caption {Latency distribution for $t_d(N)$ from Internet-scale DCS measurements with mean $2.1$s and its LN approximation with mean $1.04$s in a log-log scale.}
  \label{fig:t_d_N_approximation}
\end{figure}

The focus of our approximation is to preserve the primary behavior of the pool maintenance mechanism, which is the constant replenishment of the pool of $N$ peers, resulting in frequently establishing connections to remote peers, thus incurring latencies over the Internet, while still considering rare events such as finding an unreachable peer or a long-termed capability/parameter negotiation albeit with low probability only. These considerations lead us to a log-normal (LN) approximation for $t_d(N)$, shown in Fig. \ref{fig:t_d_N_approximation} with log-mean $\mu_d$ and $\sigma_d$, denoted as:
%$\mu_d=5.86$ and $\sigma_d=1.46$
\begin{equation}\label{eq:tdN}
  t_d(N)\sim \ln \mathcal{N}(\mu_d,\,\sigma_d^{2})
\end{equation}

As we can see from Eq. \ref{eq:tdN} and Fig. \ref{fig:t_d_N_approximation}, there is some, albeit small, probability for long diffusion times $t_d(N)$ and thus also long convergence time $t_m$ for achieving distributed consensus. 
% For more details on $t_d(N)$ and goodness-of-fit, we refer to Appendix \ref{app:a}.

\subsubsection{Distribution of the Uniqueness of Peers}\label{sect:uniqueness_diffusion}

Let us now turn to the uniqueness distribution in Eq. \ref{eq:model}, i.e., $u(t)$. At each iteration, selecting a set of peers impacts this uniqueness factor. This peer selection occurs in the discovery phase of the overall peer pool maintenance \cite{Guzman2022, Cruciani2023, Maymounkov2002} as follows, exemplified in Figure \ref{fig:ktree} for Ethereum and further detailed in \cite{Maymounkov2002, Wood2014,Nakamoto2008} for other systems:

\begin{figure}[ht]
  \centering
  \includegraphics[width=0.49\textwidth]{image/ktree}
  \caption{Sorting Peers based on Binary Log Distance}
  \label{fig:ktree}
\end{figure}

Each peer aims at locally creating a unique and independent \textit{ID}, determined from the \textit{most significant bits} (MSBs) of the digest over its public key, which in turn is derived from local pseudo-random-number generators \cite{Wood2014}. Any incoming or outgoing ID, i.e., either those actively discovering a peer or those being discovered by the peer, are then sorted into random \textit{buckets of tuples}, which include the peer's IP address and its ID, and arranged by the \textit{binary log distance} (XOR metric) relative to the local ID \cite{Maymounkov2002}. Thus, each peer discovers and sorts peerIDs based on its own ID as well as samples from this sorted list for creating a pool of peers of size $N$.

\begin{figure}[ht]
  \centering
  \includegraphics[width=0.24\textwidth]{image/u_t_matrix}
  \includegraphics[width=0.19\textwidth]{image/p-distribution-ecdf}
  \caption{(left) Sample of $u(t)$, and (right) ECDF for, $p_j$, selection probability for a peer $j$ out of $S$.}
  \label{fig:u_t_matrix}
\end{figure}

Key for our model is to determine the uniqueness of those sets (across the peers participating in the iteration process) to derive the possible duplication of diffusions, which in turn harms the convergence time $t_m$.

As an indicative example, Fig. \ref{fig:u_t_matrix} shows $u(t)$ based on observations for set intersections for a single peer ID over ten selections of $N=50$ peers, a default fanout configuration for DCS clients such as \textit{geth} \cite{goethereum}. Since a local peer continuously renews its pool of active peers, this mechanism is the same across the entire system. For instance, selecting $N=50$ peers at the ninth iteration, column nine in Fig. \ref{fig:u_t_matrix}, collides with the first selection, i.e., all $N=50$ peers are the same compared to the initially selected ones, red tile. If a peer diffused information to unique peers at each iteration, the entire matrix in Fig. \ref{fig:u_t_matrix} would be yellow. Instead, we can notice the high correlation between chosen sets for a single peer ID, shown as red squares in Fig. \ref{fig:u_t_matrix}. Such high correlation is inherent to the random selection approach, worsened by highly active super-peers \cite{Guzman2022, Kim2018} because the size $N$ of selections is much larger than the default configuration, e.g., thousands \cite{Gao2019, Kim2018, Guzman2022}.

Consequently, we require more insights into the distribution of those sets from iteration to iteration across all peers. For this, we consider the sequence of choices made by a peer $r_0$ as an independent and identically distributed (i.i.d.) selection process since the ID sorting scheme ensures that the entire DCS ID space is explored, while the sampling process ensures random picks from sorted IDs \cite{Maymounkov2002}.

With this in mind, a peer $r_0$ diffuses information to $N$ random peers drawn from the set $S$ of active peers. Each of the $N$ peers diffuses again independently to other $N$ remote peers, randomly selected from the same set of active peers.

This process randomly executes $k$ selections in a set of $S$ peers, where $k$ grows exponentially from initially $k=N=50$ with each iteration since each selected peer, in turn, will cause executing $N$ selections again.

We can model this process through a discrete random variable $\mathbf{b}$, which counts the number of selections of peers $\mathbf{r}= \left[ r_1,\dots,r_S \right]$ after $k$ i.i.d. random trials. Then, a peer $r_i$ is picked $b_i$ times; hence, the set of peers $\mathbf{r}$ are randomly hit or selected as $\mathbf{b}= \left[b_1,\dots,b_S\right]$ times. Consequently, the probability of observing a vector of \textit{occurrences} $\mathbf{b}$ is given by a multinomial distribution, parametrized by $\mathbf{p}=\left[p_1,\dots,p_S\right]$, as follows \cite{Rasmussen2016}:

\begin{equation}
  \mathbb{P}(\mathbf{b}|\mathbf{p},k) = \frac{k!}{b_1!\dots b_S!} \prod_{i=1}p_i^{b_i}, \quad \forall k,b_i \in \mathbb{N}^+, p_i \in \left[0,1\right],
\end{equation}

where $p_i$ is the probability of choosing $b_i$ times a peer $r_i$ out of $k$ trials, with $\sum_{i=1}^{S}p_i=1$.

Intuitively, the marginal distribution $b_j$ follows a binomial distribution, where the expected times a peer $r_j$ is chosen is defined as $\mathbb{E}(b_j)=kp_j$ with variance $\mathbb{V}(b_j)=kp_j(1-p_j)$.

Here, $\mathbf{p}$ is vital for the uniqueness definition. If selecting a peer $r_j$ were equally likely for all $j$, then $p_j=\frac{1}{S}$. However, there are super-peers to pick with higher probability than $\frac{1}{S}$ since those super-peers spread their ID to more than the default $N=50$ peers due to their higher individual peer degree \cite{Guzman2022, Kim2018}. We show in Fig. \ref{fig:u_t_matrix} that the assumption $p_j=\frac{1}{S}$ is nonetheless plausible.

With the above in mind, it follows that $\mathbb{E}(b_j)=\frac{k}{S}$ with variance $\mathbb{V}(b_j)=\frac{k}{S}(1-\frac{1}{S})$. Further, we define the expected unique peers \textit{up to} a certain diffusion iteration $x$ from the expected times a peer $r_j$ is selected, as:

\begin{equation}\label{eq:u_t_expectation}
  \mathbb{E}(u_j) = \frac{k^{x+1}}{\ln N}(1-\frac{k^{x+1}}{S\ln N}),
\end{equation}

where $k^{x+1}/\ln N$ denotes peers selected up to iteration $x$. Now, each iteration can be described as a time-dependent variable for a diffusion size $N$ with

\begin{equation}
  \mathbb{E}(u_j) = \frac{N^{1+t/t_d(N)}}{\ln N}(1-\frac{N^{1+t/t_d(N)}}{S\ln N})
\end{equation}

Then, we derive the factor $u(t)$ as a uniqueness upper bound over the total number of peers up to iteration $N^{t/t_d(N)}$ as

\begin{equation}\label{eq:u_t}
  u(t) = (1-\frac{N^{1+t/t_d(N)}}{S\ln N}), \quad \forall u(t) \in \left[0,1\right],
\end{equation}

refining our initial model in Eq. \ref{eq:model} to

\begin{equation}\label{eq:model_final}
  m < (N-\frac{N^{2+t/t_d(N)}}{S \ln N})^{t/t_d(N)},
\end{equation}

with $N^{2+t/t_d(N)}/S\ln N \leq 1$.

The latter implies $t_S \approx t_d(N)(\log_N S -1)$, outlining the existence of a moment in the iterative diffusion after which all peers are exhausted, continuing with information propagation to all peers only by means of expensive duplicated communication. In other words, the iterative process continues diffusing to all $S$ peers until $t>t_S$, with diffusion to the majority of peers until $t_m$ for ensuring consensus. However, for the diffusion at each timestep $t$, the system draws exponentially growing trials, and, as time passes, the cost for repeated sampling of peers also inevitably grows high.

\begin{figure}[ht]
  \centering
  \includegraphics[width=0.24\textwidth]{image/peers-vs-t-non-u-a}
  \includegraphics[width=0.24\textwidth]{image/peers-vs-t-non-u-b}
  \caption{Baseline diffusion, i.e., Eq. \ref{eq:model} with $u(t)=1$, against the randomized diffusion model, i.e., Eq. \ref{eq:model_final} with $u(t)<1$, with parameters (a) $S=63,N=2,t_d(N)=0.001$s, and (b) $S=72$k$,N=50,t_d(N)=0.200$s.}
  \label{fig:results-non-uniqueness}
\end{figure}

Let us illustrate this effect in comparison to ensuring full uniqueness of peers throughout the iterations, with Fig. \ref{fig:results-non-uniqueness}a illustrating a small scale DCS with just $S=63$ peers and Fig. \ref{fig:results-non-uniqueness}b for real DCS parameters, derived from \cite{Guzman2022, Kim2018}. There is a marked decline already before reaching $t_m$, which is even higher for $t>t_m$, particularly for Fig. \ref{fig:results-non-uniqueness}b, ultimately slowing down finality, reaching all $S$ peers, of the diffusion process at time $t>t_S$ as illustrated in Fig. \ref{fig:results-non-uniqueness}b.

From Fig. \ref{fig:results-non-uniqueness}, we can derive a performance indicator $g$ which compares the model, i.e., non-uniqueness diffusion, against a baseline diffusion based on a complete unique selection of peers at each step in a given time $t_m$ through:

\begin{equation}\label{eq:model_final_factor}
  g= \int_{0}^{t_m} \frac{(u(t)N)^{t/t_d(N)}}{N^{t/t_d(N)}}dt
  % =\int_{0}^{t_m}\frac{S^{t/t_d(N)}}{(S-N^{t/t_d(N)})^{t/t_d(N)}}dt
\end{equation}

In Fig. \ref{fig:results-non-uniqueness}a, this performance factor is $g=3.06$, which implies that a DCS system in a best-case scenario with a baseline diffusion, i.e., complete uniqueness $u(t)=1$, finds three times more unique peers in a given time compared to the randomized selection approach; hence, the diffusion up to the majority rule is delayed by the same factor $g \cdot t_m$.

Furthermore, we notice $g \approx 1$ for the short time regime in Fig. \ref{fig:results-non-uniqueness}a and Fig. \ref{fig:results-non-uniqueness}b. In fact, $g = 1.1$ when comparing a baseline diffusion against a randomized one for an Internet-scale DCS with $S \gg N$ up to $t_m$ in Fig. \ref{fig:results-non-uniqueness}b, and it increases up to $g = 1.25$ when considering diffusion up to $t_S$. The latter means \textit{the randomization process slows down diffusion on average to $25\%$ per single request}.

\begin{figure}[ht]
  \centering
  \includegraphics[width=0.39\textwidth]{image/peers-vs-t-non-u-ho}
  \caption{Comparison for baseline diffusion, i.e., Eq. \ref{eq:model} with $u(t)=1, t_d(N)_1=0.200$s \cite{Hoiland2016}, against the randomized diffusion model, i.e., Eq. \ref{eq:model_final} with $t_d(N)_2=2.1$s, both with $S=72$k$,N=50$, resulting in $t_{m_1}=0.336$s, $t_{m_2}=3.962$s and $t_{S_2}=4.977$s in a log-log scale}
  \label{fig:results-non-uniqueness-ho}
\end{figure}

Combining our insights into the diffusion latency and the uniqueness distributions, we can contrast the above baseline derived from Eq. \ref{eq:model} against the empirical diffusion model provided in Eq. \ref{eq:model_final}. Through our results shown in Fig. \ref{fig:results-non-uniqueness-ho} as the times for achieving the majority rule $t_{m_1}$ for the baseline model against $t_{m_2}$ for the randomized empirical model, we conclude that our empirical insights have stretched the latency bound for achieving the majority rule by a factor of $11.7$, which conversely means that \textit{a system without randomization can be at least $11.7$ times faster at diffusing information to achieve consensus at Internet scale}.

%[1] "tm= 336.361978458356 tm2: 3962.6804682179 tm2/tm= 11.781 tS2= 4977.43665338574"

% \dirk{I do not like this paragraph above: this is THE crucial final result and I still cannot read the key number in the text but must decipher it from the figure caption!!! Why do we need to even compare the ideal diffusion with average Internet latency (which we have shown to be non-sense assumptions) against what matters, which is the randomized diffusion with measured average latency??? Then, what does it mean `both systems require few interactions....'?? Then, why stating that the non-uniqueness delays the diffusion without stating the number since we have already stated that the delayed diffusion occurs - what matters is the ultimate result. So simply state that against an ideal diffusion with Internet latency at xx seconds, our refined emperical model shows an increase to yy seconds. Finally, argue the bounding without randomization to 11.7 times more - is this shown in Figure 7 or doesn't it come from a previous insight? This paragraph needs more direct punch but also mroe direct reference to what is written before!}

%[1] "tm= 336.361978458356 tm2: 3962.6804682179 tm2/tm= 11.781 tS2= 4977.43665338574"

% \textcolor{red}{Comments Dirk: Is this correct? I would d argue that we would need to compare a simple 200ms $t_d$ curve with $u(t)=1$ with that of u(t) based on Eq. 7, then one with $t_d=2142ms$ where u(t) is based on Eq 7 as well as u(t)=1. But in fact, I would argue that you only need the border cases, i.e., from $t_d=200ms$ and u(t)=1 to $t_d=2142$ and u(t) based on Eq 7. Maybe that is what this figure does show but it is not clear. If so, the takeaway is surely not that a system with no randomization can be at least 9 times faster, is it?}

\subsection{Model for DCaaS-based Multicast Diffusion}\label{sect:DCaaS-multicast-model}

% - \info{A: The almost trivial multicast topology that is the result of a single replication point per continent with all RPs interconnected in a full mesh is disappointingly unrealistic.}

% - \info{A: a more ambitious evaluation in a more complex topology (possibly with several layers) could further strengthen the case for your approach}

% - \info{D: The “Model for DCaaS-based Multicast Diffusion” which relates to the proposed approach is a short and very simplistic, elementary and questionable one. }

% \dirk{this could be addressed with the new insights on clustering, thus also basing the strawman evaluation on emperical evidence.}

% \david{RESP}

\begin{figure}[ht]
  \centering
  \includegraphics[width=0.48\textwidth]{image/bar_peers_nodes_isp}
  \includegraphics[width=0.48\textwidth]{image/clusters_nodes_isp}
  % \includegraphics[width=0.48\textwidth]{image/clusters_peers_isp_country}
  \caption{Distribution and clustering of peers for an Internet-scale DCS based on measurements for Ethereum. (a) Cluster size for the top 10 infrastructures. (b) Cluster geographical spread for the top 10 infrastructures.}
  \label{fig:multicast_infrastructure_distribution}
\end{figure}

%PEERs
% isp peers  per_peer
% 1:                     Hetzner Online GmbH 10923 9.6435855
% 2:                Amazon Technologies Inc.  9988 8.8181024
% 3:                        DigitalOcean LLC  6003 5.2998667
% 4:               Amazon Data Services NoVa  5976 5.2760292
% 5:                            Contabo GmbH  5756 5.0817979
% 6:                              Google LLC  3749 3.3098784
% 7: China Mobile Communications Corporation  3507 3.0962240
% 8:                         Amazon.com Inc.  3158 2.7881024
% 9:              Amazon Data Services Japan  3015 2.6618521
% 10:                                IPXO LLC  2289 2.0208887
% 11:    Amazon Data Services Ireland Limited  2064 1.8222430
% 12:          Amazon Data Services Singapore  1638 1.4461405
% 13:                                 OVH SAS  1490 1.3154758
% 14:                 Amazon Data Services UK  1468 1.2960527
% 15:                           A100 ROW GmbH  1360 1.2007028
% 16:        Comcast Cable Communications LLC  1308 1.1547935
% 17:         AWS Asia Pacific (Seoul) Region  1302 1.1494963
% 18:                   Microsoft Corporation  1037 0.9155359
% 19:                      Vultr Holdings LLC   908 0.8016457
% 20:              Charter Communications Inc   887 0.7831054

% sum(head(log_isp,10)$per_peer)
% [1] 47.99

% iso_a2 isp   peers      X     Y
% <chr>  <chr> <int>  <dbl> <dbl>
% 1 US     ATI.   6761 -112.   45.7
% 2 DE     HOGH   5568   10.4  51.1
% 3 US     ADSN   4730 -112.   45.7
% 4 FI     HOGH   4074   26.3  64.5
% 5 DE     CGmH   3828   10.4  51.1
% 6 CN     CMCC   3389  104.   36.6
% 7 JP     ADSJ   2046  138.   37.6
% 8 US     GLLC   1729 -112.   45.7
% 9 US     A.I.   1723 -112.   45.7
% 10 US     DOLL   1191 -112.   45.7

Let us now outline a model for the diffusion process based on multicast.
For this, we detail the peer clustering behavior and its complexity from the passive measurements previously outlined in Section \ref{sect:comparison:iterative}.
The clusters are identified on the basis of an infrastructure provider, i.e., autonomous system (AS), cloud provider, or hyper-scaler, and its complexity is based on a geographical spread for each cluster.

For this, a map between an Ethereum node ID, an IP address, and an autonomous system number (ASN) permits the identification of infrastructure clusters.
In Fig. \ref{fig:multicast_infrastructure_distribution}a, we characterize the concentration size of peers in well-known infrastructure providers.
This infrastructure clustering is also reported in \cite{Tumas2023} for XRP Ledger and in \cite{Grundmann2022} for Bitcoin.
For example, the top infrastructure provider, HOGH in Fig. \ref{fig:multicast_infrastructure_distribution}a, hosts $10k$ peers $\approx 9.6\%$ of the total peers in the DCS.
Indeed, $47.9\%$ of the peers rely on $10$ out of $3795$ infrastructures.

To estimate the geo spread for each infrastructure, we map each peer IP address to a geographic location to describe the convex hull of an infrastructure cluster, where the geolocation mapping to an IP address is guaranteed with $99\%$ accuracy \cite{IpLocation2023}. This assumption allows us to compare each cluster's geographic span based on country centroids from empirical results as depicted in Fig. \ref{fig:multicast_infrastructure_distribution}b.
For instance, in Fig. \ref{fig:multicast_infrastructure_distribution}b, the maximum span area corresponds to the GLLC cluster, which is spread across countries such as Canada, USA, Chile, Brazil, Australia, Japan, France, and Finland hosting $3.7$k peers or $3.3\%$ of the peers in the DCS, with a geographic maximum span given by a convex hull with area equal to $20650 km^2$.

The geometric approach is not a topological representation of the internal infrastructure provider.
Instead, our empirical convex hulls relate to physical connectivity in terms of locations of peers and geographical distances as well as aspects of logical clustering, bounding the connectivity span in private backbone infrastructures. We use this geo span as a weight for the infrastructure complexity and latency to design an enhanced DCS overlay network.

We assume an RP overlay deployed globally with one RP per infrastructure, located in a focal area within the convex hull given by the nation-wide cluster size, and serving peers distributed in those providers as per Fig. \ref{fig:multicast_infrastructure_distribution}b, with Ethereum as the example. A country within an infrastructure convex hull hosting most peers defines a focal area. For example, in the case of HOGH, the RP serving $6k$ out of $10.9k$ peers is located in Germany.

RPs are connected in a partial mesh with peers announcing their services to the nearest infrastructure RP, using unique established relations as described in Sections \ref{sect:daas:proposed} and \ref{sect:daas:strawman} that avoid the latency variances induced by the processes for reachability checks, connection establishment, and capability exchange that iterative diffusion approaches must rely on.

% \begin{figure}[ht]
%   \centering
%   \includegraphics[width=0.48\textwidth]{image/ecdf_latencies_isp}
%   \includegraphics[width=0.48\textwidth]{image/boxplot_latencies_isp_c_country}
%   \includegraphics[width=0.48\textwidth]{image/boxplot_latencies_isp_clu_country}
%   \caption{Latency distribution in clustering of peers for an Internet-scale DCS based on measurements for Ethereum. Further details can be found in Appendix \ref{app:c}.}
%   \label{fig:multicast_infrastructure_latency_distribution}
% \end{figure}

The majority rule constrains the diffusion process, i.e., needing to send to $m$ peers.
As outlined in Section \ref{sect:daas:strawman}, the initiator inquires the DCS size from its local RP, being able to thus determine $m$ and provide it as part of the initiating request to its RP, which in turn distributes to its neighboring RPs until reaching their local peers.
Hence, two tiers of the overlay multicast mesh support the diffusion, where the overall diffusion delay, $t_{d_m}$, is bounded through

\begin{equation}\label{eq:model_multicast}
  t_{d_m}=2 \cdot t_a+2 \cdot t_p+t_e+t_c, \quad \forall  t_a,t_p,t_e,t_c \in \mathbb{R}^+,
\end{equation}

with $t_a \leq 0.200$s being the communication delay between a peer and the nearest RP at the originator and destination RP side. $t_p$ is the maximum processing packet latency at an RP, and $t_e$ a maximum peering delay from infrastructure to infrastructure with the most prolonged inter-infrastructure delay, i.e., between CMCC-ADSN in Fig. \ref{fig:multicast_infrastructure_distribution}b, bounding this delay to $t_e \leq 0.100$s \cite{Hoiland2016,Dang2021}, and $t_c$ being a maximum time to propagate information in infrastructures as outlined in \cite{Salamatian2022,Salamatian2023} with the highest delay for GLLC in Fig. \ref{fig:multicast_infrastructure_distribution}b equal to $t_c \leq 0.333$s \cite{Hoiland2016}.

Further, to bound the packet processing delay $t_p$, we consider that each RP handles maximum $10$k service instances, derived from the distribution in Fig. \ref{fig:multicast_infrastructure_distribution}b. Thus, an RP processes $10$k requests in $t_p \leq 0.025$s given that steering mechanisms handle $\approx400000$ $\text{reqs/s}$ as in \cite{Parola2023} where packet processing relies on in-kernel implementations.

With the above, we compare the time to diffuse to $m$ peers in an iterative diffusion fashion, $t_{m_2}$ as per Fig. \ref{fig:results-non-uniqueness-ho}, against the time achieved by our strawman approach, $t_{d_m}$ from Eq. \ref{eq:model_multicast}, as

\begin{equation}\label{eq:model_multicast_comparison}
  t_{m_2}/t_{d_m} = 3.962/(0.4 + 0.05 + 0.1 + 0.333) = 4.486
\end{equation}

% \dirk{DO NOT MIX metrics in the equation, it is not helping to understand the numbers. It is either 4900/(333+50+100) or it is 4.9 / (0.333 + 0.050 + 0.100) Do also not jump between metrics. Since you used milliseconds mostly before, stick with it!}

\textit{improving thus the time to reach consensus by a factor of $4.5$}. This needs to be understood as a minimal performance improvement since we upper-bounded the latencies for our strawman approach. Moreover, the possibility for large convergence times in rare cases caused by the long tail delay distributions in our iterative diffusion model is removed in our strawman approach. Overall, this result aligns with our expected performance improvement noted in the previous section as part of our insights into \textit{baseline} iterative diffusion.

From our insights in Fig. \ref{fig:results-non-uniqueness-ho}, we can further compare the time for diffusing to the entire DCS $t_{S_2}$ to the upper bounded latencies for our strawman approach as

\begin{equation}\label{eq:finality_model_multicast_comparison}
  t_{S_2}/t_{d_m} = 4.977/(0.4 + 0.05 + 0.1 + 0.333) = 5.636
\end{equation}

However, the real nature of the improvement here lies beyond the number in Eq. \ref{eq:finality_model_multicast_comparison} since the distributed nature of the iterative diffusion makes the judgment of finality, i.e., the completion of the diffusion process, impossible to judge after the 4.977s provided in Fig. \ref{fig:results-non-uniqueness-ho}. Instead, diffusion attempts will continue among peers until the peer-local selection process will ultimately stop the diffusion; even at that point, an individual peer may not be able to judge finality of the diffusion without an explicit coordination among the peers.

Here, the controlled sending to $d$ peers in our strawman provides an enormous qualitative advantage over the iterative diffusion in that finality can be judged through the finality of the performed overlay multicast operation; thus, our bound of $(0.4 + 0.05 + 0.1 + 0.333)  = 0.883s$ provides not just a bound for diffusing to the majority of peers but also for judging the achievement of consensus, i.e., finality, itself.

% \dirk{The above puzzles me a bit. Eq (10) is using $t_{s_2}$ which is the time to diffuse to ALL S peers. This is the finality time while $t_{m_2}$ is the convergence time, right. So should not the first factor be that of $t_{m_2}$/(333 + 50 + 100) ms?? Why do you choose the words `a least 10.3' when comparing with $t_{S_2}$ though? I know that this is the delay to achieve finality but it is not that finality can be judged after 4.9s in Ethereum, can it, so it is a distributed phenomena!? So I suggest to stick with comparison against $t_{m_2}$ and handle the whole finality part differently (to be discussed how) }

%the factor for the average is computed as : \frac{3962.68}{200 + 42.5 + 100}

%the factor for IFIP is computed as : \frac{3962.68}{200 + 25 + 100}
%after Dirks comment :
% 3.9/(0.333 + 0.050 + 0.100)
% 3.9/.483 = 8
%after Joergs comment :
% 3.9/(0.4 + 0.333 + 0.050 + 0.100)
% 3.962/.883 = 8

We shall also note that RP-supported multicast diffusion avoids the high percentage of duplicated communication found in the randomized approach due to actively maintaining service instances at each RP and performing the replication only once. We leave the evaluation of the resulting cost savings due to avoiding unnecessary communication to future work.

\textit{The key takeaway from a randomized iterative diffusion compared to a multicast approach is that the latter cannot only improve in factors of around 4 for the majority rule and around 5 for the finality of consensus, but it also ensures that the diffusion ends and the completion time is known.}

\section{Discussion}\label{sect:discussion}

%- \info{C: The authors do not evaluate or even discuss the cost of implementing an overlay infrastructure, and the related practical implications.}

%\dirk{should be covered in previous text on positioning this on data plane performance.}

% DIRK: I think we covered this in the intro (focus of paper) and additional text in start of Section IV.

%\dirk{Given those improvements, we can foresee DCS deployments that entirely forego working on inconsistent states, thus removing another key impact factor of existing DCS deployments caused by the experienced long confirmations. Instead, the more rapid consensus achieved through a multicast-based approach may remove the need for expensive proof methods and, therefore, reduce the carbon footprint of a DCS.}

%\dirk{RESP}
% DIRK: we have this aspect in the third paragraph below, don't we?

Let us discuss a few aspects concerning our model insights and assumptions made throughout its development.

Although empirical insights into Ethereum played a key role, we assert its \textit{transferability} to other DCSs, such as Bitcoin and Algorand, since its consensus mechanism applies randomized communication \cite{Guzman2022, Cai2021, Cruciani2023, Dimitri2022}. Furthermore, it is extensible to other restrictions, such as for Byzantine faults in \cite{Lamport2019, Castro1999}, where higher constraints are required to tackle failures and malicious behavior.

Another critical aspect is the impact of our results on the need for methods to \textit{work on inconsistent state}. These methods are required to continue operations during an ongoing convergence process, as observed in \cite{Wood2014, Nakamoto2008}. Here, typical approaches use, e.g., Proof-of-Work or Proof-of-Stake methods, however, incurring expensive system instabilities through decision forking and often consuming expensive computational and communication resources \cite{Drusinsky2022}. We argue that our evaluation insights provide DCS providers with better tools to limit the convergence time, thus allowing them to tune DCS operations towards desired operational parameters (e.g., an expected convergence time boundary to achieve) as well as provide better capabilities to estimate the necessary costs for the methods mentioned above such as PoW or PoS for those periods where operations on inconsistent state are needed.

Further, we assert that our strawman for overlay multicast for DCS diffusion may push a DCS towards much \textit{shorter periods of inconsistency}. More so, the insights on bounding the latency may allow DCS operators to entirely avoid expensive PoW or PoS methods if the latency lies beyond a desired bound for the operations of the larger computational problem that utilizes the DCS. For instance, reducing the block time based on the finality delay from minutes to seconds as in DCSs such as Bitcoin \cite{Nakamoto2008} reduces the computation required to perform hashing operations to find blocks, i.e., mining. However, this situation depends on the specific DCS application and its required convergence time boundaries. We argue that a more profound study across various DCS applications may provide the needed insights to move from iterative diffusion to overlay multicast to improve the overall environmental impact of the DCS.

% The presented evaluation model is transferable to other diffusion processes executed in DCSs such as Bitcoin and Algorand since randomization is at the heart of its diffusion scheme in its consensus mechanisms, i.e., gossip protocols \cite{Gilad2017,Dimitri2022,Wood2014,Nakamoto2008}. In fact, it is moldable for different small and large-scale parameters. Those parameters, such as the majority rule, introduced in Section \ref{sect:comparison} can be considered a reference for the exponential growth in Eq. \ref{eq:model_final}. Moreover, it can be extended to different bounds, such as the ones for Byzantine faults in \cite{Lamport2019, Castro1999}, where higher constraints are imposed to tackle failures and malicious behavior. Although we did not present $N$ with a long tailed distribution, \cite{Guzman2022}, we determine performance indicators as lower bounds, expecting worst performance in real systems, the latter due to variance considerations such as the ones shown for latency $t_d(N)$ in Section \ref{sect:diffusion_latency}.
%7. Decrease number of peers reported for the new Ethereum network ETHv2 etherscan 2023

In addition to the benefits of the time-bounded convergence in our strawman, further insights are required into \textit{deployment aspects}. Our initial proposal in this paper outlines an infrastructure-based RP deployment, leading to a simple partial mesh of RPs to handle the complexity of the private backbone. Other models may include city-wide deployments or a mix depending on the geographical distribution of peers. What remains unchanged is the strict time bound on convergence; merely additional bounded latencies may need to be accounted for when adding tiers of distribution into the multicast system.

Furthermore, moving from a purely peer-based system to a system built atop an overlay of RPs may require revisiting some key \textit{security aspects}, such as establishing confidential channels between the initiator of the diffusion and its (many) recipients. Such confidentiality may not be required end-to-end and be merely ephemeral, e.g., between RP and peer at the local diffusion step. Similar considerations may apply to the confidentiality of IP addresses, where announcing to RPs instead of diffusing one's IP address to possibly many if not all, peers in the DCS for iterative diffusion may change the private nature of the DCS, possibly requiring a trust relation with the DCS platform but not with the individual peers. This approach may remove a fundamental weakness of existing DCSs where individual peers may misuse the peer discovery process to scrape many other peers' public IP address information for, e.g., denial of service attacks \cite{Rasolroveicy2022}. Moreover, such trust relation is independent of the enhancements to the consensus convergence latency since the assumed adversaries (Byzantine peers) remain the same, i.e., $2/3$ of the total peers \cite{Castro1999} or the majority rule while achieving consensus \cite{Newman1956}.

% \info{A: Some brief discussion of obvious concerns regarding system reliability and robustness against adversarial actions would have been appreciated.}

% \dirk{need to see if possible to do spacewise}

% \david{RESP: the threat model is independent of the speed of the diffusion.}


% \info{B: The claims are overstated, such as "Our results [...] ultimately allow for making better judgements on the finality of the diffusion, [...] avoiding the retrieval of significant state information from participating peers for those convergence checks" - I am not sure that this is proven in the paper. }

% \dirk{Need to specify this ability more clearly, I think}

% \joerg{RESP}

\section{Conclusion}\label{sect:conclusion}

Achieving the majority rule over the distributed state is at the heart of any DCS. The mechanism's efficacy to diffuse to at least the majority of all DCS peers drives a vital portion of the DCS's cost and usefulness regarding latency bounds.

In this paper, we shed light on the impact of the randomized algorithms in existing DCSs on the time to converge to a single state. For this, we formalized an exponential growth model that captures the iterative diffusion process in those systems. We bounded the key parameters of this model through experimental insights derived from real systems, here Ethereum, to lead to expectations for the convergence in those systems. We specifically showed that convergence times achieved through iterative diffusion exceed those of ideal diffusion (achieved through unique peer distribution) by at least 25\%.

While our model and results aim to guide DCS platform operators in their configurations alongside quality-of-operation expectations, it also allows for comparison against other diffusion approaches. Here, we specifically showed that a system that applies overlay multicast for diffusion might lead to significant improvements in convergence time of a minimum of 4x for the majority rule and 5x for the finality, with an ensured finality of the consensus.

In future work, we envision quantifying the practical cost savings from this key design difference at the Internet scale.

\bibliographystyle{IEEEtranS}
\bibliography{bibliography,rfc}
% \appendices
% \section{}
% \subsection{Log-Normal Distribution of Latency}\label{app:a}

% \begin{figure}[ht]
%   \centering
%   \includegraphics[width=0.47\textwidth]{image/t_d_N-gof}
%   \caption{Details for $t_d(N)$ measurements and its LN approximation.}
%   \label{fig:t_d_N_fit}
% \end{figure}

% The goodness-of-fit analysis for the latency distribution introduced in Section \ref{sect:diffusion_latency} and in Fig. \ref{fig:t_d_N_fit} is based on \cite{Clauset2009}. We detail the fitted distribution and its test statistics to validate the plausibility of an LN approximation. For this, we observe the local behavior in the right tail of the Q-Q plot in Fig. \ref{fig:t_d_N_fit} and notice the measured delay is more spread out than the approximation at the tenth quantile, meaning longer measured delays than the predicted ones only for the long tail. This measured delay mainly corresponds to system configuration time-outs being an anomaly easy to avoid and not general.

% \subsection{Probability Distribution for Peer Selection}\label{app:b}

% \begin{figure}[ht]
%   \centering
%   \includegraphics[width=0.22\textwidth]{image/p-distribution}
%   \includegraphics[width=0.22\textwidth]{image/p-distribution-ecdf}
%   \caption{Details for measurements of peer, $r_j$, selections (left) histogram of peer ID selections,$p_j$ (right) ECDF for $p_j$.}
%   \label{fig:u_t_fit}
% \end{figure}

% In Fig. \ref{fig:u_t_fit}, we show the peer selection behavior based on the sorted and digested public keys from peers deployed over the Internet. On the left, we notice spikes in the selection probability; this corresponds precisely to several super-peers. A super-peer is more likely to be picked since it constantly propagates its ID to more peers. However, this behavior does not prevent approximating this selection distribution to a uniform distribution, as shown in Fig. \ref{fig:u_t_fit}(right) and used to derive Eq. \ref{eq:u_t_expectation} in Section \ref{sect:uniqueness_diffusion}.

% \subsection{Peer Distribution}\label{app:c}

% \begin{figure}[ht]
%   \centering
%   \includegraphics[width=0.38\textwidth]{image/ecdf_peer_isp}
%   % \includegraphics[width=0.47\textwidth]{image/ecdf_countries_isp}
%   \caption{Peer Distribution across Infrastructure Providers.}
%   \label{fig:ecdf_peer_isp}
% \end{figure}

% In Fig. \ref{fig:multicast_infrastructure_distribution} in Section \ref{sect:DCaaS-multicast-model}, we detailed the top 10 clustered infrastructures. In Fig. \ref{fig:ecdf_peer_isp}a, we detail the scale of peer clustering for the discovered infrastructures across Ethereum.
% %  and in Fig. \ref{fig:ecdf_peer_isp}b, we detail the span in terms of political divisions for the given infrastructure clusters.

% % IN_PING%>% group_by(isp)%>% reframe(peers=n_distinct(IP),countries=n_distinct(iso_a2))%>%arrange(desc(peers))
% % # A tibble: 3,795 × 3
% %    isp                                     peers countries
% %    <chr>                                   <int>     <int>
% %  1 Hetzner Online GmbH                     10022         5
% %  2 Amazon Technologies Inc.                 7999        13
% %  3 DigitalOcean LLC                         5494         8
% %  4 Contabo GmbH                             4895        12
% %  5 Amazon Data Services NoVa                4730         1
% %  6 China Mobile Communications Corporation  3389         1
% %  7 Google LLC                               2969        22
% %  8 Amazon.com Inc.                          2471        12
% %  9 Amazon Data Services Japan               2192         2
% % 10 Amazon Data Services Ireland Limited     1530         1

% % isp                             peers country
% % <chr>                           <int>   <int>
% % 1 M247 Europe SRL                   130      25
% % 2 Google LLC                       2969      22
% % 3 DataCamp Limited                  143      20
% % 4 Microsoft Corporation             696      18
% % 5 Oracle Corporation                307      17
% % 6 G-Core Labs S.A.                   26      14
% % 7 Stark Industries Solutions Ltd.    79      14
% % 8 Amazon Technologies Inc.         7999      13
% % 9 PQ Hosting S.r.l.                  98      13
% % 10 Amazon.com Inc.                  2471      12


% We detail the precise size of the clusters in terms of peers and the percentage of the DCS they represent per infrastructure in Table \ref{tbl:infrastructures_percentage}. Additionally, we add a column as a cumulative sum representing the majority rule (MR).

% % \setcounter{magicrownumbers}{0}
% % \begin{table}[ht]
% %   \begin{center}
% %   \caption{Peers Geographic Distribution}
% %   \label{tbl:infrastructures}
% %   \begin{tabular}{|c|c|c|}
% %   \hline
% %    & Infr. & Infr. Abbr. \\
% %   \hline
% %   \rownumber & Amazon Technologies Inc. & ATI. \\ \rownumber & Hetzner Online GmbH & HOGH \\ \rownumber & Amazon Data Services NoVa & ADSN \\ \rownumber & Contabo GmbH & CGmH \\ \rownumber & China Mobile Communications Corporation & CMCC \\ \rownumber & Amazon Data Services Japan & ADSJ \\ \rownumber & Google LLC & GLLC \\ \rownumber & Amazon.com Inc. & A.I. \\ \rownumber & Amazon Data Services Ireland Limited & ADSIL \\ \rownumber & Amazon Data Services Singapore & ADSS \\ \rownumber & Amazon Data Services UK & ADSU \\ \rownumber & DigitalOcean LLC & DOLL \\ \rownumber & A100 ROW GmbH & A1RG \\ \rownumber & Comcast Cable Communications LLC & CCCL \\ \rownumber & AWS Asia Pacific (Seoul) Region & AAP(R \\ \rownumber & IPXO LLC & IPXL \\ \rownumber & OVH SAS & OVHS \\ \rownumber & Charter Communications Inc & ChCI \\ \rownumber & Hetzner Online AG & HOAG \\
% %   \hline
% %   \end{tabular}
% %   \end{center}
% % \end{table}

% \setcounter{magicrownumbers}{0}
% \begin{table}[ht]
%   \begin{center}
%   \caption{Peers Infrastructure Distribution}
%   \label{tbl:infrastructures_percentage}
%   \begin{tabular}{|c|c|c|c|c|c|}
%   \hline
%    & Infrastructure & Abbr. & Peers [k] & \% & \% MR \\
%   \hline
%   \rownumber & Hetzner Online GmbH & HOGH & 10.9 & 9.5 & 9.5  \\ \rownumber & Amazon Technologies Inc & ATI. & 10.0 & 8.7 & 18.2  \\ \rownumber & DigitalOcean LLC & DOLL & 6.1 & 5.3 & 23.4  \\ \rownumber & Amazon Data Services No & ADSN & 6.0 & 5.2 & 28.6  \\ \rownumber & Contabo GmbH & CGmH & 5.8 & 5.0 & 33.6  \\ \rownumber & Google LLC & GLLC & 3.8 & 3.3 & 36.9  \\ \rownumber & China Mobile Communicat & CMCC & 3.5 & 3.0 & 40.0  \\ \rownumber & Amazon.com Inc. & A.I. & 3.2 & 2.7 & 42.7  \\ \rownumber & Amazon Data Services Ja & ADSJ & 3.0 & 2.6 & 45.3  \\ \rownumber & IPXO LLC & IPXL & 2.3 & 2.0 & 47.3  \\ \rownumber & Amazon Data Services Ir & ADSIL & 2.1 & 1.8 & 49.1  \\ \rowcolor{gray}\rownumber & Amazon Data Services Si & ADSS & 1.6 & 1.4 & 50.5 \\ 
%   % \rownumber & OVH SAS & OVHS & 1.5 & 1.3 & 51.8  \\ \rownumber & Amazon Data Services UK & ADSU & 1.5 & 1.3 & 53.1  \\ \rownumber & A100 ROW GmbH & A1RG & 1.4 & 1.2 & 54.3  \\ \rownumber & Comcast Cable Communica & CCCL & 1.3 & 1.1 & 55.4  \\ \rownumber & AWS Asia Pacific (Seoul & AAP(R & 1.3 & 1.1 & 56.6  \\ \rownumber & Microsoft Corporation & McrC & 1.0 & 0.9 & 57.5  \\ \rownumber & Vultr Holdings LLC & VHLL & 0.9 & 0.8 & 58.2  \\ \rownumber & Charter Communications  & ChCI & 0.9 & 0.8 & 59.0  \\ \rownumber & Hetzner Online AG & HOAG & 0.9 & 0.8 & 59.8  \\ \rownumber & GCI Network Solutions L & GNSL & 0.8 & 0.7 & 60.5  \\ \rownumber & ChinaNet Guangdong Prov & CGPN & 0.8 & 0.7 & 61.2  \\ \rownumber & Verizon Business & VrzB & 0.7 & 0.6 & 61.8  \\ \rownumber & Oracle Public Cloud & OrPC & 0.7 & 0.6 & 62.4  \\ \rownumber & OVH US LLC & OVUL & 0.6 & 0.5 & 63.0  \\ \rownumber & Tencent Cloud Computing & TCC(CL & 0.6 & 0.5 & 63.5  \\ \rownumber & BoloPlus & BlPl & 0.6 & 0.5 & 64.0  \\ \rownumber & ChinaNet Zhejiang Provi & CZPN & 0.5 & 0.5 & 64.5  \\ \rownumber & Aliyun Computing Co. Lt & ACCL & 0.5 & 0.5 & 64.9  \\
% \hline
% \end{tabular}
% \end{center}
% \end{table}

% \subsection{Convex Hulls for Infrastructure Geographical Span}\label{app:d}

% In Table \ref{tbl:weights}, we detail the corresponding area for each convex hull in Fig. \ref{fig:multicast_infrastructure_distribution}b used in Section \ref{sect:DCaaS-multicast-model} to model the multicast diffusion.

% \setcounter{magicrownumbers}{0}
% \begin{table}[ht]
%   \begin{center}
%   \caption{Convex Hulls Geographical Span}
%   \label{tbl:weights}
%   \begin{tabular}{|c||c|c|c|c|c|c|c||c|c|c|}
%   \hline
%   Infrastructure & HOGH &  ATI. &  DOLL &  ADSN &  CGmH  \\  
%   Span [$km^2$] & 1284.0 &  15283.0 &  6985.9 &  9826 &  7684.2 \\
%   \hline
%   \hline
%   Infrastructure & GLLC & CMCC &  A.I. &  ADSJ &  IPXL \\
%   Span [$km^2$] &  20650.7 & 9597 &  11501.9 &  377 &  4064.7 \\
%   \hline
%   \end{tabular}
%   \end{center}
%   \end{table}

% \subsection{Focal Areas within Infrastructures Convex Hulls}\label{app:e}

% In Table \ref{tbl:focal_areas}, we exemplified the countries that serve the higher amount of peers within each infrastructure hull described in Fig. \ref{fig:multicast_infrastructure_distribution} in Section \ref{sect:DCaaS-multicast-model}.

% % head(location_guide,20)
% % # A tibble: 20 × 3
% %    iso_a2 isp   peers
% %    <fct>  <chr> <int>
% %  1 US     ATI.   8280
% %  2 DE     HOGH   6011
% %  3 US     ADSN   5976
% %  4 FI     HOGH   4478
% %  5 DE     CGmH   4474
% %  6 CN     CMCC   3507
% %  7 JP     ADSJ   2802
% %  8 US     GLLC   2180
% %  9 US     A.I.   2101
% % 10 US     DOLL   1340
% % 11 US     IPXL   1201
% % 12 DE     DOLL   1081
% % 13 SG     DOLL   1010
% % 14 GB     CGmH    984
% % 15 NL     DOLL    897
% % 16 LT     IPXL    826
% % 17 GB     DOLL    738
% % 18 SG     ATI.    570
% % 19 IN     DOLL    479
% % 20 CA     DOLL    444

% \setcounter{magicrownumbers}{0}
% \begin{table}[ht]
%   \begin{center}
%   \caption{Peer Clusters per Infrastructure Convex Hull}
%   \label{tbl:focal_areas}
%   \begin{tabular}{|c||c|c|c|c|c|}
%   \hline
%   Country (ISO A2) & US &  DE &  US &  FI &  DE \\ 
%   Infrastructure & ATI. &  HOGH &  ADSN &  HOGH &  CGmH \\
%   Peers [k] & 8.3 &  6.0 &  6.0 &  4.5 &  4.5 \\
%   \hline
%   \hline
%   Country (ISO A2) & CN &  JP &  US &  US &  IE \\ 
%   Infrastructure & CMCC &  ADSJ &  GLLC &  A.I. &  ADSIL \\
%   Peers [k] &  3.5 &  2.8 &  2.2 &  2.1 &  2.1 \\
%   \hline
%   \end{tabular}
%   \end{center}
%   \end{table}


% % \setcounter{magicrownumbers}{0}
% % \begin{table}[ht]
% %   \begin{center}
% %   \caption{Peers Geographic Distribution per Infrastructure}
% %   \label{tbl:clusters}
% %   \begin{tabular}{|c|c|c|c|c|c|c|c|c|}
% %   \hline
% %   & Infr. & Peers & \% DCS & Loc. & Peers & \% Infr. & \% DCS & \% \\
% %   \hline
% %   \rownumber & ATI. & 10.0 & 8.7 & US & 8.3 & 82.9 & 7.2 & 7.2 \\ \rownumber & HOGH & 10.9 & 9.5 & DE & 6.0 & 55.0 & 5.2 & 12.4 \\ \rownumber & ADSN & 6.0 & 5.2 & US & 6.0 & 100.0 & 5.2 & 17.6 \\ \rownumber & HOGH & 10.9 & 9.5 & FI & 4.5 & 41.0 & 3.9 & 21.5 \\ \rownumber & CGmH & 5.8 & 5.0 & DE & 4.5 & 77.7 & 3.9 & 25.4 \\ \rownumber & CMCC & 3.5 & 3.0 & CN & 3.5 & 100.0 & 3.0 & 28.4 \\ \rownumber & ADSJ & 3.0 & 2.6 & JP & 2.8 & 93.0 & 2.4 & 30.9 \\ \rownumber & GLLC & 3.8 & 3.3 & US & 2.2 & 58.1 & 1.9 & 32.8 \\ \rownumber & A.I. & 3.2 & 2.7 & US & 2.1 & 66.6 & 1.8 & 34.6 \\ \rownumber & ADSIL & 2.1 & 1.8 & IE & 2.1 & 100.0 & 1.8 & 36.4 \\ \rownumber & ADSS & 1.6 & 1.4 & SG & 1.6 & 100.0 & 1.4 & 37.8 \\ \rownumber & ADSU & 1.5 & 1.3 & GB & 1.5 & 99.7 & 1.3 & 39.1 \\ \rownumber & DOLL & 6.1 & 5.3 & US & 1.4 & 22.8 & 1.2 & 40.3 \\ \rownumber & A1RG & 1.4 & 1.2 & DE & 1.4 & 99.9 & 1.2 & 41.5 \\ \rownumber & CCCL & 1.3 & 1.1 & US & 1.3 & 100.0 & 1.1 & 42.6 \\ \rownumber & AAP(R & 1.3 & 1.1 & KR & 1.3 & 100.0 & 1.1 & 43.8 \\ \rownumber & IPXL & 2.3 & 2.0 & US & 1.2 & 52.5 & 1.0 & 44.8 \\ \rownumber & DOLL & 6.1 & 5.3 & DE & 1.1 & 17.8 & 0.9 & 45.7 \\ \rownumber & OVHS & 1.5 & 1.3 & FR & 1.0 & 67.9 & 0.9 & 46.6 \\ \rownumber & DOLL & 6.1 & 5.3 & SG & 1.0 & 16.7 & 0.9 & 47.5 \\ \rownumber & CGmH & 5.8 & 5.0 & GB & 1.0 & 17.1 & 0.9 & 48.4 \\ \rownumber & DOLL & 6.1 & 5.3 & NL & 0.9 & 14.9 & 0.8 & 49.1 \\ \rownumber & ChCI & 0.9 & 0.8 & US & 0.9 & 100.0 & 0.8 & 49.9 \\ \rowcolor{lightgray} \rownumber & HOAG & 0.9 & 0.8 & DE & 0.9 & 100.0 & 0.8 & 50.7 \\ \rownumber & IPXL & 2.3 & 2.0 & LT & 0.8 & 36.1 & 0.7 & 51.4 \\ \rownumber & CGPN & 0.8 & 0.7 & CN & 0.8 & 100.0 & 0.7 & 52.1 \\ \rownumber & VrzB & 0.7 & 0.6 & US & 0.7 & 100.0 & 0.6 & 52.7 \\ \rownumber & DOLL & 6.1 & 5.3 & GB & 0.7 & 12.2 & 0.6 & 53.3 \\ \rownumber & OVUL & 0.6 & 0.5 & US & 0.6 & 100.0 & 0.5 & 53.9 \\ \rownumber & BlPl & 0.6 & 0.5 & GB & 0.6 & 100.0 & 0.5 & 54.4 \\
% %   \hline
% %   \end{tabular}
% %   \end{center}
% %   \end{table}

% % \setcounter{magicrownumbers}{0}
% % \begin{table}[ht]
% %   \begin{center}
% %   \caption{Peers Geographic Distribution}
% %   \label{tbl:cluster_countries}
% %   \begin{tabular}{|c|c|c|}
% %   \hline
% %    & Country \\
% %   \hline
% %   \rownumber & US \\ \rownumber & DE \\ \rownumber & FI \\ \rownumber & CN \\ \rownumber & JP \\ \rownumber & IE \\ \rownumber & SG \\ \rownumber & GB \\ \rownumber & KR \\ \rownumber & FR \\ \rownumber & NL \\
% %   \hline
% %   \end{tabular}
% %   \end{center}
% % \end{table}

% % \begin{table}[ht]
% % \begin{center}
% % \caption{Peers Geographic Distribution}
% % \label{tbl:countries}
% % \begin{tabular}{|c|c|c|}
% % \hline
% % Country & Peers $\left[k\right]$ & Percent $\left[\%\right]$ \\
% % \hline
% % USA & 19.5 & 28.1 \\ Germany & 15.1 & 21.8 \\ Singapore & 4.4 & 6.3 \\ Finland & 4.0 & 5.8 \\ China & 3.7 & 5.3 \\ Netherlands & 2.9 & 4.1 \\ United Kingdom & 2.8 & 4.1 \\ Japan & 2.3 & 3.4 \\ Canada & 2.2 & 3.1 \\ Ireland & 1.9 & 2.7 \\
% %India & 1.7 & 2.5 \\ Russia & 1.2 & 1.8 \\ France & 1.1 & 1.6 \\ South Korea & 0.8 & 1.2 \\ Hong Kong S.A.R. & 0.8 & 1.2 \\ Australia & 0.3 & 0.5 \\ Switzerland & 0.3 & 0.5 \\ Poland & 0.2 & 0.4 \\ Taiwan & 0.2 & 0.3 \\ Belgium & 0.2 & 0.3 \\ Unknown & 0.9 & 1.2 \\
% % 947 peers not geographically identified out of 72k
% % \hline
% % \end{tabular}
% % \end{center}
% % \end{table}

% % We detail in Table \ref{tbl:countries} the precise amount of peers and their corresponding percentage in exemplified Ethereum deployment. We summarize the top ten countries which run Ethereum nodes used in Section \ref{sect:DCaaS-multicast-model} to derive $t_p$ in Eq. \ref{eq:model_multicast}.
% % We also observe that from the entire data set in \cite{Guzman2022}, $943$ peers out of $72$k could not be translated from its public IP address to a location.

\end{document}
